#! /usr/bin/perl
#
# Sample CGI to explain to the user that the URL is blocked and by which rule set
#
# By Pl Baltzersen 1998
#

$QUERY_STRING = $ENV{'QUERY_STRING'};
$DOCUMENT_ROOT = $ENV{'DOCUMENT_ROOT'};

$clientaddr = "";
$clientname = "";
$clientident = "";
$srcclass = "";
$targetclass = "";
$url = "";
$time = time;
@day = ("Dimanche","Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi");
@month = ("Janvier","Fevrier","Mars","Avril","Mai","Juin","Juillet","Aout","Septembre","Octobre","Novembre","Decembre");

while ($QUERY_STRING =~ /^\&?([^&=]+)=([^&=]*)(.*)/) {
  $key = $1;
  $value = $2;
  $QUERY_STRING = $3;
  if ($key =~ /^(clientaddr|clientname|clientident|srcclass|targetclass|url)$/) {
    eval "\$$key = \$value";
  }
  if ($QUERY_STRING =~ /^url=(.*)/) {
    $url = $1;
    $QUERY_STRING = "";
  }
}

if ($url =~ /\.(gif|jpg|jpeg|mpg|mpeg|avi|mov)$/i) {
  print "Content-Type: image/gif\n";
  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime($time);
  printf "Expires: %s, %02d-%s-%02d %02d:%02d:%02d GMT\n\n", $day[$wday],$mday,$month[$mon],$year,$hour,$min,$sec;
  open(GIF, "$DOCUMENT_ROOT/images/blocked.gif");
  while (<GIF>) {
    print;
  }
  close(GIF)
} else {
  print "Content-type: text/html\n";
  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime($time);
  printf "Expires: %s, %02d-%s-%02d %02d:%02d:%02d GMT\n\n", $day[$wday],$mday,$month[$mon],$year,$hour,$min,$sec;
  print "<HTML>\n\n  <HEAD>\n    <TITLE>302 Acces interdit</TITLE>\n  </HEAD>\n\n";
  print "  <BODY BGCOLOR=\"#FFFFFF\">\n";
  if ($srcclass eq "unknown") {
    print "    <H1 ALIGN=CENTER>Acces interdit a cause du<BR>client qui n est pas<BR>defini dans le Proxy</H1>\n\n";
    print "    <TABLE BORDER=0 ALIGN=CENTER>\n";
    print "      <TR><TH ALIGN=RIGHT>Information supplementaire<TH ALIGN=CENTER>:<TH ALIGN=LEFT>\n";
    print "      <TR><TH ALIGN=RIGHT>Adresse du client<TH ALIGN=CENTER>=<TH ALIGN=LEFT>$clientaddr\n";
    print "      <TR><TH ALIGN=RIGHT>Nom du client<TH ALIGN=CENTER>=<TH ALIGN=LEFT>$clientname\n";
    print "      <TR><TH ALIGN=RIGHT>Identification du client<TH ALIGN=CENTER>=<TH ALIGN=LEFT>$clientident\n";
    print "      <TR><TH ALIGN=RIGHT>Groupe du client<TH ALIGN=CENTER>=<TH ALIGN=LEFT>$srcclass\n";
    print "    </TABLE>\n\n";
    print "    <P ALIGN=CENTER>S il y a un probleme, contacter votre Administrateur reseau<BR>\n";
    print "    </P>\n\n";
  } elsif ($targetclass eq "in-addr") {
    print "    <H1 ALIGN=CENTER>L adresse IP de l URL<BR>n est pas autorise<BR>a partir de ce client</H1>\n\n";
    print "    <TABLE BORDER=0 ALIGN=CENTER>\n";
    print "      <TR><TH ALIGN=RIGHT>Information supplementaire<TH ALIGN=CENTER>:<TH ALIGN=LEFT>\n";
    print "      <TR><TH ALIGN=RIGHT>Adresse du client<TH ALIGN=CENTER>=<TH ALIGN=LEFT>$clientaddr\n";
    print "      <TR><TH ALIGN=RIGHT>Nom du client<TH ALIGN=CENTER>=<TH ALIGN=LEFT>$clientname\n";
    print "      <TR><TH ALIGN=RIGHT>Identification du client<TH ALIGN=CENTER>=<TH ALIGN=LEFT>$clientident\n";
    print "      <TR><TH ALIGN=RIGHT>Groupe du client<TH ALIGN=CENTER>=<TH ALIGN=LEFT>$srcclass\n";
    print "      <TR><TH ALIGN=RIGHT>URL<TH ALIGN=CENTER>=<TH ALIGN=LEFT>$url\n";
    print "      <TR><TH ALIGN=RIGHT>Categorie de la cible<TH ALIGN=CENTER>=<TH ALIGN=LEFT>$targetclass\n";
    print "    </TABLE>\n\n";
    print "    <P ALIGN=CENTER>S il y a un probleme, contacter votre Administrateur reseau<BR>\n";
    print "    </P>\n\n";
  } else {
    print "    <P ALIGN=RIGHT>\n";
    print "    </P><p></p>\n\n";
    print "    <BR><BR><BR><BR><p align=\"center\"><font size=\"7\" face=\"arial\" color=\"#FF0000\"><b>ACCES INTERDIT</font></b><BR>\n\n";
    print "    <TABLE BORDER=0 ALIGN=CENTER>\n";
    print "      <TR><BR><BR><TH ALIGN=RIGHT>L adresse IP de votre Ordinateur<TH ALIGN=CENTER>=<TH ALIGN=LEFT>$clientaddr\n";
    print "      <TR><TH ALIGN=RIGHT>URL non autorise<TH ALIGN=CENTER>=<TH ALIGN=LEFT>$url\n";
    print "    </TABLE>\n\n";
    print "    <p align=\"center\"><font size=\"3\" face=\"Arial\">Si le site web doit etre accessible, contacter votre administrateur reseau.<BR><font>\n";
    print "    </P>\n\n";
  }
  print "  </BODY>\n\n</HTML>\n";
}
exit 0;
